/* This file contains frequently-used abstractions and macros */

#if !defined(TYPEH)
#define TYPEH

/**********************
 * STANDARD LIBRARIES *
 **********************/

#include <stdio.h>	/* if this isn't first, I get "NULL
redefined" error */

#include <ctype.h>
#include <math.h>
#include <stdarg.h>
#include <stddef.h>
#include <string.h>

/* #include <stdlib.h> */
/* can't find malloc.  why not? */
void *malloc();

/* *other stuff now */

#define TRUE  1
#define FALSE 0

typedef char *String;	/* String is an array of chars (pointer to a char) */
typedef char Bool;

typedef void *Pointer;
#define psize sizeof(Pointer)

typedef struct consstruct
{ Pointer car;
  struct consstruct *cdr;
} Cons;

typedef struct stringcons
{ String car;
  struct stringcons *cdr;
} Scons;

/* I depend on the fact that the size of a char is 1, which is the samllest
   size and which divides every other size. */
typedef struct bagstruct
{ 
  int locs;		/* the number of memory locations */
  int size;		/* all elements before this one hold data */
  int eltsize;		/* the size of each element */
  Pointer array;	/* array of elements */
} Bag;

#define BAGNOLOC -1	/* not an index into a bag */

#endif /* end of file; nothing should go after this */

