/* Header file for my C utilities */

#include "c-type.h"


/* ***************************************************************************
   MACROS
   ****** */

#define testint(exp1, exp2)	\
do { int val1 = exp1; \
     int val2 = exp2; \
     if (val1 != val2) \
       error("Unequal values %d and %d for %s and %s.", \
	     val1, val2, #exp1, #exp2); } while (0)

#define teststring(exp1, exp2)	\
do { String val1 = exp1; \
     String val2 = exp2; \
     if (strcmp(val1, val2)) \
       error("Unequal values %s and %s for %s and %s.", \
	     val1, val2, #exp1, #exp2); } while (0)

#define testchar(exp1, exp2)	\
do { char val1 = exp1; \
     char val2 = exp2; \
     if (val1 != val2) \
       error("Unequal values %c (%d) and %c (%d) for %s and %s.", \
	     val1, val1, val2, val2, #exp1, #exp2); } while (0)


/* ***************************************************************************
   FUNCTION PROTOTYPES
   ******************* */

/* Errors */
void error(char *fmt, ...);
void errdie(char *fmt, ...);

/* Strings */
Bool strequal(String s, String t);
String strwrtrim(String s);
String wsqueeze(String s);

int intcmp_forsort(int *a, int *b);
int charcmp_forsort(char *a, char *b);
int strcmp_forsort(String *a, String *b);

